#include <fstream>
#include <vector>
using namespace std;

ifstream fin("arbvalmax.in");
ofstream fout("arbvalmax.out");

#define N 300005
vector<int> G[N];
int n, m;
int vmax;
int val[N];
int lant[N]; /// lant[x] = val max pe lantul care coboara din radacina si se termina in x
int mx[N];   /// initial, mx[x] = maximul pt nodurile din stanga lantului x-y
             /// adica  a nodurilor explorate si terminate
int t[N];

// la terminarea nodului x, gmax retine maximul din stanga lantului [1..x] + maximul
// din subarborele cu rad in x, iar mx[nod] = vmax - val[nod]
// la coborare spre nod, Dfs culege in gmax toate maximele din stanga lantului (fara lant)
void DfsL(int x)
{
    lant[x] = max(lant[t[x]], val[x]);
    for (int y : G[x])
        DfsL(y);
    mx[x] = max(mx[x], vmax);
    vmax = max(vmax, val[x]);
}

// updateaza vmax cu maximul din dreapta lantului [1..x] + maximul din subarborele cu rad in x,
void DfsR(int x)
{
    for (int i = G[x].size() - 1; i >= 0; --i)
        DfsR(G[x][i]);
    mx[x] = max(mx[x], vmax);
    vmax = max(vmax, val[x]);
}

int main()
{
    fin >> n >> m;
    for(int i = 2; i <= n; ++i)
    {
        fin >> t[i];
        G[t[i]].push_back(i);
    }

    for (int i = 1; i <= n; ++i)
        fin >> val[i];

    DfsL(1);
    vmax = 0;
    DfsR(1);

    for (int i = 0, x, y; i < m; ++i)
    {
        fin >> x >> y;
        fout << max(lant[t[x]], mx[y]) << '\n';
    }

    return 0;
}
