#include <fstream>
#include <vector>
using namespace std;

ifstream fin("tree.in");
ofstream fout("tree.out");

const int Inf = 1 << 30;

using VB  = vector<bool>;
using VI  = vector<int>;
using VVI = vector<VI>;

int n, P;

VVI a;   /// a[x][i] = nr minim de taieturi ca sa avem un subarbore
         /// cu rad in x cu i noduri
VVI G;
VI sz;   /// sz[x] = greutatea subarborelui cu rad in x
VB v;
// nr minim de taieturi (cerinta)
int min_t = Inf;


void Citeste();
void Df(int x);

int main()
{
	Citeste();
	Df(1);

	fout << min_t;
}

void Df(int x)
{
	v[x] = true;
	a[x][1] = G[x].size(); /// daca izolez complet nodul x
	sz[x] = 1;

	for (const int& f : G[x])
	{
		if (v[f]) continue; // daca f e tata lui x
		Df(f); // calculeaza a[f][1], a[f][2], ..., a[f][P]
		VI aux(a[x]);
		for (int i = 1; i <= P && i <= sz[x]; ++i) // nr de noduri in x
			for (int j = 1; i + j <= P && j <= sz[f]; ++j)
			{
				if (a[x][i] == Inf || a[f][j] == Inf) continue;

				if (a[x][i] + a[f][j] - 2 < aux[i + j])
					aux[i + j] = a[x][i] + a[f][j] - 2;
			}

		a[x] = aux;
		sz[x] += sz[f];
	}

	min_t = min(min_t, a[x][P]);
}

void Citeste()
{
	fin >> n >> P;
	a = VVI(n + 1, VI(P + 1, Inf));
	v = VB(n + 1);
	sz = VI(n + 1);
	int x, y;

	for (int i = 1; i < n; ++i)
	{
		fin >> x >> y;
		G[x].push_back(y);
		G[y].push_back(x);
	}
}

