#include <fstream>
#include <vector>
using namespace std;

ifstream fin("tree.in");
ofstream fout("tree.out");

const int Inf = 1 << 30;

using VB  = vector<bool>;
using VI  = vector<int>;
using VVI = vector<VI>;

int n, P;

VVI G;
VI sz;   // sz[x] = greutatea subarborelui cu rad in x
VB v;
// nr minim de taieturi (cerinta)
int min_t = Inf;

void Citeste();
VI Df(int x);

int main()
{
	Citeste();
	Df(1);

	fout << min_t;
}

VI Df(int x)
{
	VI X(P + 1, Inf); // X[i] = nr min de taieturi pt un subarb cu rad in x cu i noduri

	v[x] = true;
	X[1] = G[x].size(); // daca izolez complet nodul x
	sz[x] = 1;

	for (const int& f : G[x])
	{
		if (v[f]) continue; // daca y e tata lui x
		VI F = Df(f);      //  F =  a[f][1], a[f][2], ..., a[f][P]
		VI aux(X);
		for (int i = 1; i <= P && i <= sz[x]; ++i) // nr de noduri in x
			for (int j = 1; i + j <= P && j <= sz[f]; ++j)
			{
				if (X[i] == Inf || F[j] == Inf) continue;
				aux[i + j] = min(aux[i + j], X[i] + F[j] - 2);
			}

		X = aux;
		sz[x] += sz[f];
	}

	min_t = min(min_t, X[P]);
	return X;
}

void Citeste()
{
	fin >> n >> P;
	v = VB(n + 1);
	sz = VI(n + 1);
	int x, y;

	for (int i = 1; i < n; ++i)
	{
		fin >> x >> y;
		G[x].push_back(y);
		G[y].push_back(x);
	}
}

