/// O(N * K * K)

#include <iostream>
#include <fstream>
#include <vector>
using namespace std;

ifstream fin("iepuri.in");
ofstream fout("iepuri.out");

const int MOD = 30011;

vector<vector<int> > G;
int n, k;
vector<vector<int>> a;  /// a[x][i] - nr de moduri de a colora (plasa valori) intr-un subarbore cu rad in x
                        /// daca in x plasez culoarea (valoarea) i
int root;
vector<int> grad; /// gradele interioare ale varfurilor

void Dfs(int nod);
void Read();

int main()
{
	Read();

	Dfs(root);
	int res = 0;
	for (int i = 1; i <= k; ++i)
	{
		res += a[root][i];
		if ( res > MOD)
			res -= MOD;
	}

	fout << res << '\n';

	fin.close();
	fout.close();
	return 0;
}

void Dfs(int x)
{
	a[x].assign(k + 1, 1);
	for (const int& f : G[x])
	{
		Dfs(f);
		vector<int> Aux(k + 1);

		for (int i = 1; i <= k; ++i)  /// in nodul x pun valoarea i
			for (int j = i + 1; j <= k; ++j)  /// in f pun j
			{
				Aux[i] += (a[x][i] * a[f][j]) % MOD;
				if (Aux[i] > MOD)
					Aux[i] -= MOD;
			}
		a[x] = Aux;
	}

}

void Read()
{
	cin >> n >> k;
	G = vector<vector<int>>(n + 1);
	a = vector<vector<int>>(n + 1));
	grad = vector<int>(n + 1);

	int x, y;
	for( int i = 1; i < n; ++i )
	{
		cin >> x >> y;
		G[x].push_back(y);
		++grad[y];
	}

	for (int i = 1; i <= n; ++i )
		if (!grad[i])
		{
			root = i;
			break;
		}
}





