/// Sa se det nr de lanturi de cost K intr-un arbore (cu costuri pe muchii).
/// O(N * K)

#include <fstream>
#include <vector>
#include <bitset>
using namespace std;

const int NMAX = 1e4 + 1;
const int MOD = 321555123LL;

ifstream fin("arb.in");
ofstream fout("arb.out");

using VP = vector<pair<int, int>>;
using VB = vector<bool>;
using VI = vector<int>;
using VVP = vector<VP>;

int n, k;
VVP G;
VB v;

long long ans;

VI Dfs(int node);

int main()
{
	fin >> n >> k;
	G = VVP(n + 1);
	v = VB(n + 1);

	for (int i = 1, x, y, w; i < n; ++i)
	{
		fin >> x >> y >> w;
		G[x].emplace_back(y, w);
		G[y].emplace_back(x, w);
	}

	Dfs(1);

	fout << ans << '\n';

	return 0;
}

VI Dfs(int x)
{
	v[x] = true;
	VI X(k + 1);  /// X[i] = nr de lanturi care coboara din x, de cost i
	X[0] = 1;

	for (auto [y, w] : G[x])
	{
		if (v[y]) continue;
		VI F = Dfs(y);
		for (int i = 0; i <= k - w; ++i)
		{
			ans += 1LL * X[i] * F[k - i - w];
			ans %= MOD;
		}

		for (int i = w; i <= k; ++i)
		{
			X[i] += F[i - w];
			if (X[i] >= MOD)
				X[i] -= MOD;
		}
	}
	return X;
}
