// Constantin Galatan
// Complexitate: O(N*K*S*S)

#include <vector>
#include <iterator>
#include <fstream>
using namespace std;

ifstream fin("autostrazi.in");
ofstream fout("autostrazi.out");

#define Mod 30011
using VI  = vector<int>;
using VVI = vector<VI>;
VI r;
VVI G;
int N, K;
int S;

VI Df(int x, int father);
void ReadGraph();

int main()
{
	ReadGraph();

	VI v = Df(1, 0);

	int sol = 0;
	for (int i = 0; i <= S; ++i)
	{
		sol += v[i];
		sol %= Mod;
	}

	fout << sol << '\n';
	fout.close();
	return 0;
}

VI Df(int x, int father)
{
	VI X(S + 1);  /// X[j] numărul de posibilităţi de a plasa costuri pe muchii  în subarborele cu rădăcina în x,
	              /// astfel încât j sa fie  cel mai mare cost între nodul X si oricare nod din subarbore.

	X[0] = 1;
	for (const int& son : G[x])
	{
		if ( son == father ) continue;

		VI F = Df(son, x);
		VI A(S + 1);  // Auxiliar

		for (int i = 0; i <= K; ++i)  // pe muchie
			for (int k = 0; k + r[i] <= S; ++k)           // fiu
				for (int j = 0; k + r[i] + j <= S; ++j)   // x
					if (j >= k + r[i])
					{
						A[j] += (X[j] * F[k]) % Mod;
						A[j] %= Mod;
					}
					else
					{
						A[k + r[i]] += (X[j] * F[k]) % Mod;
						A[k + r[i]] %= Mod;
					}
		X = A;
	}
	return X;
}

void ReadGraph()
{
	fin >> N >> S >> K;
	G = VVI(N + 1);
	r = VI(K + 1);

	for (int i = 1; i <= K; ++i )
		fin >> r[i];
	int x, y;
	for (int i = 0; i < N - 1; ++i )
	{
		fin >> x >> y;
		G[x].push_back(y);
		G[y].push_back(x);
	}
	fin.close();
}

